#!/bin/sh
set -e

read_device_id(){
    /bin/dd if="$1" bs=512 count=1 skip=$2 iflag=direct 2>/dev/null | head -c 32
}

is_swissbit_device(){
    # We have to read the identifier twice, since the device might return
    # the underlying flash data on the first read and the identifier only
    # after the second read.
    for sector in 26 13;do
        read_device_id "$1" > /dev/null 2>&1
        device_id=$(read_device_id "$1" $sector)
        if [ "$device_id" = "Swissbit-SFC-SD-ccv1" ] || [ "$device_id" = "Swissbit-SFC-SD-ccv2" ]; then
            return 0
        fi;
    done
    return 1
}

if [ "$1" = "mount" ];then
    # DEVNAME is defined by udev daemon before execute this script
    if is_swissbit_device "${DEVNAME}"; then
        date +"[%c] Swissbit iShield Card detected" >> /var/log/iat.log
        chmod 666 "${DEVNAME}"
    fi
fi
